Program TresD;

Uses Crt;

Const
  PANT = $A000;
  MAXCARAS = 100;
  MAXCOL = 4;
  XCENTRO = 160;
  YCENTRO =100;
  RANGO = 4;

Type
  Punto = Record
            x, y, z : Real;
          End;

  Plano = Record
           color : Array [1..RANGO] of Byte;
           vert : Array [1..4] of Punto;
           normal : Punto;
         End;

  Objeto = Record
             n : Integer;
             cara : Array [1..MAXCARAS] of Plano;
             alfa, beta, gamma : Integer;
             pos : Punto;
             escala : Integer;
           End;

Var
  offs : Array [0..199] of Word;
  Virt : ^Byte;
  VIR : Word;
  T : Array [0..360,1..2] of Real;
  RANGO1, RANGO2, RANGO3 : Real;
  uno, otro, ultimo : Objeto;
  f : File of Objeto;
  Luz : Punto;

Function Rad ( angulo : Integer) : Real;
  Begin
    Rad := angulo * Pi / 180;
  End;

Procedure Inicializa;
  Var
    i : Word;
  Begin
    GetMem( Virt, 64000);
    VIR := Seg( Virt^);
    For i:=0 To 199 Do
      offs[i]:=i*320;
    For i:=0 To 360 Do
      Begin
        T[i,1] := Sin( Rad(i));
        T[i,2] := Cos( Rad(i));
      End;
    RANGO1 := 1/RANGO;    RANGO2 := 2/RANGO;    RANGO3 := 3/RANGO;
  End;

Procedure LineaH ( x1, x2, y : Integer;
                   color    : Byte;
                   donde     : Word);
Assembler;
  Asm
    mov ax, [donde]
    mov es, ax
    mov bx, [y]
    shl bx, 1
    mov di, word ptr [offs + bx]
    add di, [x1]
    mov al, [color]
    mov ah, al
    db 66h
    shl ax, 16
    mov al, [color]
    mov ah, al
    mov cx, [x2]
    sub cx, [x1]
    shr cx, 1
    jnc @no_carry
    stosb
@no_carry:
    shr cx, 1
    jnc @no_carry2
    stosw
@no_carry2:
    rep
    db 66h
    stosw

  End;

Procedure Flip ( origen, destino : Word);
Assembler;
  Asm
    push ds
    mov ax, [origen]
    mov bx, [destino]
    mov ds, ax
    mov es, bx
    xor si, si
    xor di, di
    mov cx, 16000
    db 66h; rep movsw;
    pop ds
  End;

Procedure Cls (donde : Word);
Assembler;
  Asm
    mov ax, [donde]
    mov es, ax
    xor di,di
    db 66h; xor ax, ax
    mov cx, 16000
    db 66h; rep stosw
  End;

Procedure Poligono ( x1,y1,x2,y2,x3,y3,x4,y4 : Integer;
                     color : Byte;
                     donde : Word);
  Var
    maxy, miny, maxx, minx : Integer;
    i1, i2, i3, i4, j1, j2, j3, j4, y, x : Integer;
  Begin

    i1:=x1-x4;  i2:=x2-x1;  i3:=x3-x2;  i4:=x4-x3; { Para clculos posteriores }
    j1:=y1-y4;  j2:=y2-y1;  j3:=y3-y2;  j4:=y4-y3;

    If y1>y2 Then
      Begin
        maxy:=y1;  miny:=y2;
      End
    Else
      Begin
        maxy:=y2;  miny:=y1;
      End;
    If y3>maxy Then  maxy:=y3;        { Escoge el mayor y menor }
    If y4>maxy Then  maxy:=y4;
    If y3<miny Then  miny:=y3;
    If y4<miny Then  miny:=y4;

    If miny<0   Then miny:=0;          { Rango de las Y }
    If miny>199 Then Exit;
    If maxy<0   Then Exit;
    If maxy>199 Then maxy:=199;

    For y:=miny To maxy Do
      Begin
        maxx:=-1;  minx:=320;

        If (y>=y1) Or (y>=y4) Then
          If (y<=y1) Or (y<=y4) Then
            If (y1<>y4) Then
              Begin
                x := (y-y1) * i1 Div j1 + x1;
                If x > maxx Then  maxx:=x;
                If x < minx Then  minx:=x;
              End;
        If (y>=y2) Or (y>=y1) Then
          If (y<=y2) Or (y<=y1) Then
            If (y2<>y1) Then
              Begin
                x := (y-y2) * i2 Div j2 + x2;
                If x > maxx Then  maxx:=x;
                If x < minx Then  minx:=x;
              End;
        If (y>=y3) Or (y>=y2) Then
          If (y<=y3) Or (y<=y2) Then
            If (y3<>y2) Then
              Begin
                x := (y-y3) * i3 Div j3 + x3;
                If x > maxx Then  maxx:=x;
                If x < minx Then  minx:=x;
              End;
        If (y>=y4) Or (y>=y3) Then
          If (y<=y4) Or (y<=y3) Then
            If (y4<>y3) Then
              Begin
                x := (y-y4) * i4 Div j4 + x4;
                If x > maxx Then  maxx:=x;
                If x < minx Then  minx:=x;
              End;
        If maxx > 319 Then  maxx:=319;
        If minx < 0   Then  minx:=0;
        If minx < maxx   Then
           LineaH( minx, maxx, y, color, donde);
      End;
  End;

Procedure EsperaRetrazo;Assembler;
  Asm
    mov dx, $3da
@l1:
    in al, dx
    test al, 8
    jnz @l1
@l2:
    in al, dx
    test al, 8
    jz @l2
  End;

Procedure Remapea ( n, r, g, b : Byte); assembler;
    ASM
    mov al, n
    mov dx, 3c8h
    out dx, al
    inc dx
    mov al, r
    out dx, al
    mov al, g
    out dx, al
    mov al, b
    out dx, al
  End;

Procedure Modo ( num : Byte);
Assembler;
  Asm
    xor ah, ah
    mov al, num
    int 10h
  End;

Procedure Escala ( Var p : Punto; e : Integer);
  Begin
    p.x := p.x * e;
    p.y := p.y * e;
    p.z := p.z * e;
  End;

Procedure RotaX ( Var p : Punto; alfa : Integer);
  Var
    y : Real;
  Begin
    y:=p.y;
    p.y := y*T[alfa,2] - p.z*T[alfa,1];
    p.z := y*T[alfa,1] + p.z*T[alfa,2];
  End;

Procedure RotaY ( Var p : Punto; alfa : Integer);
  Var
    x : Real;
  Begin
    x:=p.x;
    p.x := p.z*T[alfa,1] + x*T[alfa,2];
    p.z := -x*T[alfa,1] + p.z*T[alfa,2];
  End;

Procedure RotaZ ( Var p : Punto; alfa : Integer);
  Var
    x : Real;
  Begin
    x:=p.x;
    p.x := p.y*T[alfa,1] + x*T[alfa,2];
    p.y := p.y*T[alfa,2] - x*T[alfa,1];
  End;

Procedure Traslada ( Var p : Punto; d : Punto);
  Begin
    p.x := p.x + d.x;
    p.y := p.y + d.y;
    p.z := p.z + d.z;
  End;

Procedure DosD ( Var x, y : Integer; p : Punto);
  Begin
    x := Round(((p.x / p.z) * 256)) + XCENTRO;
    y := Round(((p.y / p.z) * 256)) + YCENTRO;
  End;

Procedure Representa ( cosa : Objeto; donde : Word);
  Var
    x1, y1, x2, y2,x3, y3, x4, y4, i, j, normal : Integer;
    angulo : Real;

  Begin
    For i:=1 To cosa.n Do
      Begin
        For j:=1 To 4 Do
          Begin
            Escala(cosa.cara[i].vert[j], cosa.escala);
            RotaX(cosa.cara[i].vert[j], cosa.alfa);
            RotaY(cosa.cara[i].vert[j], cosa.beta);
            RotaZ(cosa.cara[i].vert[j], cosa.gamma);
            Traslada(cosa.cara[i].vert[j], cosa.pos);
          End;
          RotaX(cosa.cara[i].normal, cosa.alfa);
          RotaY(cosa.cara[i].normal, cosa.beta);
          RotaZ(cosa.cara[i].normal, cosa.gamma);
          DosD(x1,y1, cosa.cara[i].vert[1]);
          DosD(x2,y2, cosa.cara[i].vert[2]);
          DosD(x3,y3, cosa.cara[i].vert[3]);
          DosD(x4,y4, cosa.cara[i].vert[4]);
          normal := (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
          If normal > 0 Then
            Begin
              angulo:=cosa.cara[i].normal.x*Luz.x+cosa.cara[i].normal.y*Luz.y
               + cosa.cara[i].normal.z*Luz.z;
              If angulo<RANGO1 Then
                Poligono(x1,y1,x2,y2,x3,y3,x4,y4,cosa.cara[i].color[1],donde)
              Else
                If angulo<RANGO2 Then
                  Poligono(x1,y1,x2,y2,x3,y3,x4,y4,cosa.cara[i].color[2],donde)
              Else
                If angulo<RANGO3 Then
                  Poligono(x1,y1,x2,y2,x3,y3,x4,y4,cosa.cara[i].color[3],donde)
              Else
                Poligono(x1,y1,x2,y2,x3,y3,x4,y4,cosa.cara[i].color[4],donde)
            End;
      End;
  End;



Begin
  Inicializa;
  Modo($13);

  Luz.x:=0; Luz.y:=0; Luz.z:=1;
  Remapea(1,30,25,20);
  Remapea(2,40,35,20);
  Remapea(3,45,40,20);
  Remapea(4,50,45,20);
  Remapea(10,0,20,30);
  Remapea(11,0,20,40);
  Remapea(12,0,20,50);
  Remapea(13,0,20,60);
  Remapea(20,10,10,10);
  Remapea(21,20,20,20);
  Remapea(22,30,30,30);
  Remapea(23,40,40,40);
  Assign(f,'tetra.3dr');
  Reset(f);
  Read(f,uno);
  Close(f);
  uno.pos.z:=40;
  uno.pos.x:=4;
  Assign(f,'cubo.3dr');
  Reset(f);
  Read(f,otro);
  Close(f);
  otro.pos.z:=60;  otro.pos.y := 10;
  otro.pos.x:=-20;
  Assign(f,'2001.3dr');
  Reset(f);
  Read(f,ultimo);
  Close(f);
  ultimo.pos.z:=100;  ultimo.pos.y := -10;
  ultimo.pos.x:=-20;
  Repeat
    Cls(VIR);
    If otro.beta>=360 Then otro.beta:=0;
    otro.beta:=otro.beta+2;
    If otro.alfa>=360 Then otro.alfa:=0;
    otro.alfa:=otro.alfa+2;
    If otro.gamma>=360 Then otro.gamma:=0;
    otro.gamma:=otro.gamma+1;
    If ultimo.beta>=360 Then ultimo.beta:=0;
    ultimo.beta:=ultimo.beta+2;
    If ultimo.alfa>=360 Then ultimo.alfa:=0;
    ultimo.alfa:=ultimo.alfa+1;
    If ultimo.gamma>=360 Then ultimo.gamma:=0;
    ultimo.gamma:=ultimo.gamma+2;
    If uno.alfa<=0 Then uno.alfa:=360;
    uno.alfa:=uno.alfa-2;
    If uno.beta<=0 Then uno.beta:=360;
    uno.beta:=uno.beta-2;
    If uno.gamma<=0 Then uno.gamma:=360;
    uno.gamma:=uno.gamma-1;
    Representa(ultimo, VIR);
    Representa(otro, VIR);
    Representa(uno, VIR);
    EsperaRetrazo;
    Flip(VIR, PANT);
  Until KeyPressed;
  FreeMem(Virt,64000);
  Modo(3);

End.