Program TresDfichero ( Input, Output);

Uses Crt;
Const
  MAXCARAS = 100;
  RANGO = 4;

Type
  Punto = Record
            x, y, z : Real;
          End;

  Plano = Record
           color : Array [1..RANGO] of Byte;
           vert : Array [1..4] of Punto;
           normal : Punto;
         End;

  Objeto = Record
             n : Integer;
             cara : Array [1..MAXCARAS] of Plano;
             alfa, beta, gamma : Integer;
             pos : Punto;
             escala : Integer;
           End;

Var
  f : File of Objeto;
  cosa : Objeto;
  nombre : String;
  i, j : Integer;

Procedure Normal ( Var p : Plano);
  Var
    modulo,uno,dos,tres,cuatro,cinco,seis, x, y, z : Real;
  Begin
    uno := p.vert[2].x-p.vert[1].x;
    dos := p.vert[2].y-p.vert[1].y;
    tres := p.vert[2].z-p.vert[1].z;
    cuatro := p.vert[3].x-p.vert[1].x;
    cinco := p.vert[3].y-p.vert[1].y;
    seis := p.vert[3].z-p.vert[1].z;

    x := dos*seis - tres*cinco;
    y := tres*cuatro - uno*seis;
    z := uno*cinco - dos*cuatro;
    modulo := (Sqrt(Sqr(x)+Sqr(y)+Sqr(z)));
    If modulo <> 0 Then
      Begin
        p.normal.x := x / modulo;
        p.normal.y := y / modulo;
        p.normal.z := z / modulo;
      End
    Else
      Begin
        p.normal.x:=0;
        p.normal.y:=0;
        p.normal.z:=0;
      End;
  End;

Function Lee_cadena : Real;    { Lee una cadena que corresponde a un n    }

  Var
    cadena : String;
    i : Integer;
    temp : Real;
    c : Char;
    punto, menos : Boolean;

  Begin
    punto := True;  i := 0;    { Inicializa el contador. }
    menos := False;
    cadena[0] := Chr(0);       { Inicializa la longitud. }

    Repeat
      c := Readkey;
    Until c In ['0'..'9','-'];
    If c = '-' Then
      Begin
        Write('(');
        menos := True;
      End
    Else Write(' ');  { Para que ocupen los mismos espacios los negativos
                        y los positivos.                                  }

    i := i+1;
    Write(c);
    cadena[0] := Succ(cadena[0]);  { Aumenta en 1 la longitud }
    cadena[i] := c;      { Introduce el caracter en la cadena }

    Repeat
      c := Readkey;
      If  (c In ['0'..'9']) Or ((c='.') And punto) Then
        { Slo puede haber un punto y un menos al comienzo. }
        Begin      { Para que slo tenga los caracteres de un n real.     }
          If c = '.'  Then  punto := False;
          i := i+1;
          cadena[0] := Succ(cadena[0]);  { Aumenta en 1 la longitud }
          cadena[i] := c;     { Introduce el caracter en la cadena }
          Write(c);
        End
        Else  If c = Char(8) Then  { Si se pulsa Del }
          Begin
            Write(c,' ',Char(8));   { Borra el caracter anterior. }
            If cadena[i]='.'  Then punto:=True;
            i := i-1;               { Situa el ndice en la pos anterior }
            If cadena[0] = Char(1) Then  { Si es el primer caracter }
              Begin                      { puede ser un n o un menos }
                Repeat
                  c := Readkey;
                Until c In ['0'..'9','-']; { Repite la lectura del 1 }

                If c = '-' Then  { Si es un menos pone el parentesis }
                  Begin
                    Write(Char(8),'(');
                    menos := True;
                  End;
                i := i+1;
                Write(c);            { Si es un n o un - lo escribe }
                cadena[i] := c;      { Introduce el caracter en la cadena }
             End { endif }
            Else cadena[0] := Pred(cadena[0]); { Si no era el 1... }
          End; { endif }

    Until  (c = Char(13)) And (cadena[0] <> Chr(0));
                                { Hasta que se pulse Intro y la cadena   }
                                { no sea nula.                           }

    If menos Then Write(')');   { Si el numero es negativo escribe ')'   }
    Val(cadena, temp, i );      { Obtiene su valor numrico.             }
    Lee_cadena:= temp           { Devuelve el valor del n }
  End;


Begin
  WriteLn;
  Write(' Escribe el nombrecillo... ');
  ReadLn( nombre);
  Assign(f,nombre);
  Rewrite(f);  WriteLn;
  Write('Escribe el numero de caras del objeto : '); Read(cosa.n);
  For i:=1 To cosa.n Do
    Begin
      For j:=1 To 4 Do
        Begin
          Write('Escribe la X de la cara ',i,',vertice ',j,' : ');
          cosa.cara[i].vert[j].x := Lee_Cadena;  WriteLn;
          Write('Escribe la Y de la cara ',i,',vertice ',j,' : ');
          cosa.cara[i].vert[j].y := Lee_Cadena;  WriteLn;
          Write('Escribe la Z de la cara ',i,',vertice ',j,' : ');
          cosa.cara[i].vert[j].z := Lee_Cadena;  WriteLn;
        End;
      Write('Escribe el valor del primer color para el rango : ');
      ReadLn(cosa.cara[i].color[1]); WriteLn;
      cosa.cara[i].color[2]:=cosa.cara[i].color[1]+1;
      cosa.cara[i].color[3]:=cosa.cara[i].color[1]+2;
      cosa.cara[i].color[4]:=cosa.cara[i].color[1]+3;
      Normal(cosa.cara[i]);
    End;

  Sound(2000);
  Delay(1000);
  NoSound; WriteLn;
  Write(' Escribe la escala : (entera) '); ReadLn(cosa.escala);
  Write(f,cosa);
  Close(f);WriteLn;WriteLn;
  WriteLn(' El aRcHiVo hA SiDo gUaRdAdO.');
End.