{ Rubn Franco Molina }
Program Nevada;

Uses Crt;

Const
  NUMERO_COPOS = 100;
  SENCOS = 3140;
  AUMENTO = 0.002;

Type
  Copo = Record
       x , y : Integer;
       anterior : Byte;
       velocidad : Byte;
  End;
  Capullo = Array [1..NUMERO_COPOS] Of Copo;

Var
  C, S : Array [0..SENCOS] of Real;
  offs : Array [0..199] of Word;
  copos : Capullo;
  i : Word;
  r,g,b : Byte;


Procedure Inicializa;
  Var
    i : Word;
    angulo : Real;
  Begin
    angulo:=0;
    For i := 0 To SENCOS Do
      Begin
        S[i] := Sin(angulo);
        C[i] := Cos(angulo);
        angulo := angulo+AUMENTO;
      End;
    For i:=0 To 199 Do
      offs[i] := i*320;
  End;


Procedure PonPixel ( x, y : Integer; color : Byte);
Assembler;
  Asm
    mov cx, [x]
    mov bx, [y]
    cmp cx, 320
    ja @fin
    cmp bx, 200
    ja @fin
    mov ax, 0A000h
    mov es, ax
    shl bx, 1
    mov di, word ptr [offs + bx]
    add di, cx
    mov al, color
    stosb
@fin:
  End;

Function GetPixel ( x,y : Integer) : Byte;
Assembler;
  Asm
    push ds
    mov bx, [y]
    shl bx, 1
    mov si, word ptr [offs + bx]
    add si, [x]
    mov ax, 0A000h
    mov ds, ax
    lodsb
    pop ds
  End;

Procedure EsperaRetrazo;Assembler;
  Asm
    mov dx, $3da
@l1:
    in al, dx
    test al, 8
    jnz @l1
@l2:
    in al, dx
    test al, 8
    jz @l2
  End;

Procedure Remapea ( n, r, g, b : Byte); assembler;
    ASM
    mov al, n
    mov dx, 3c8h
    out dx, al
    inc dx
    mov al, r
    out dx, al
    mov al, g
    out dx, al
    mov al, b
    out dx, al
  End;

Procedure RGB ( n : Byte; Var r, g, b : Byte);
  Var
    rr,gg,bb : Byte;
  Begin
    ASM
    mov al, n
    mov dx, 3c7h
    out dx, al
    inc dx
    inc dx
    in al, dx
    mov [rr], al
    in al, dx
    mov [gg], al
    in al, dx
    mov [bb], al
    End;
    r:=rr; g:=gg; b:=bb;
  End;

Procedure Modo ( num : Byte);
Assembler;
  Asm
    xor ah, ah
    mov al, num
    int 10h
  End;


Procedure Rota ( inicio, fin : Byte);
  Var
    i : Integer;
    rt,gt,bt, r, g, b : Byte;

  Begin

    RGB(fin,rt,gt,bt);
    EsperaRetrazo;
    For i := fin Downto inicio Do
      Begin
        RGB(i-1, r, g, b);
        Remapea(i,r,g,b);
      End;
    Remapea(inicio,rt,gt,bt);
  End;

Procedure Circulo ( x, y, radio : Integer; color : Byte);
  Var
    i, j : Integer;
  Begin
    For i:=0 To SENCOS Do
      PonPixel(x+Round(radio*C[i]),y+Round(radio*S[i]),color);
    End;

Procedure CreaCopos( Var copos : Capullo);
  Var
    i : Integer;
  Begin
    For i := 1 To NUMERO_COPOS Do
      Begin
        copos[i].x := Random(320);
        copos[i].y := Random (200)-200;
        copos[i].velocidad:=Random(2)+1;
      End;
  End;

Procedure Nieve ( Var copos : Capullo);
  Var
    i, x : Integer;
    posterior, posteriord, posteriori, pos : Byte;

  Begin
    For i:=1 To NUMERO_COPOS Do
      Begin
        If copos[i].y > 0 Then
          Begin
            pos:=Getpixel(copos[i].x,copos[i].y+1);
            posterior:=Getpixel(copos[i].x,copos[i].y+copos[i].velocidad);
            posteriord:=Getpixel(copos[i].x+1,copos[i].y+copos[i].velocidad);
            posteriori:=Getpixel(copos[i].x-1,copos[i].y+copos[i].velocidad);
            If (posterior>54)Or(posteriord>54)Or(posteriori>54) Then
              Begin
                If (posterior>54) And (posteriord>54) And (posteriori>54) Then
                  x:= Random(2) - Random(2)
                Else If posterior>54   Then x := 0
                Else If posteriord>54  Then x := 1
                Else If posteriori>54  Then x := -1;
                PonPixel(copos[i].x,copos[i].y,copos[i].anterior);
                copos[i].x:= copos[i].x + x;
                copos[i].y:= copos[i].y + copos[i].velocidad;
                copos[i].anterior:=GetPixel(copos[i].x,copos[i].y);
                PonPixel(copos[i].x,copos[i].y,1);
              End
            Else
              Begin
                If copos[i].velocidad > 1 Then
                  copos[i].velocidad := 1
                Else
                  Begin
                    copos[i].y:=-1;
                    copos[i].x:=Random(320);
                    copos[i].velocidad:=Random(2)+1;
                    copos[i].anterior := Getpixel(copos[i].x,copos[i].y);
                  End;
              End;
          End
        Else
          Begin
            copos[i].y := Succ(copos[i].y);
            copos[i].anterior := Getpixel(copos[i].x,copos[i].y);
          End;
      End;

    End;

Procedure Dibujo;
  Var
    f : File of Byte;
    r,g,b : Byte;
    i, j :Integer;
  Begin
    Assign(f,'nieve.bmp');
    Reset(f);
    Remapea(0, 0, 0, 0);
    Remapea(1,63,63,63);
    Remapea(2,0,63,16);
    Remapea(3,32,16,16);
    Remapea(4,49,49,63);
    Remapea(5,0,38,38);
    Remapea(6,32,63,63);
    Remapea(255,32,32,32);
    Seek(f, $319);
    For j := 199 Downto 0 Do
      For i := 0 to 319 Do
        Begin
          Read(f,b);
          If b <> 0 Then   PonPixel(i,j,b);
        End;
  Close(f);
  End;

Begin
  Modo($13);
  Inicializa;
  For i := 0 To 199 Do
    Begin
      Remapea(i+55, 0,0,i);
      Circulo (160, 100, i, i+55);
    End;
  Dibujo;
  CreaCopos(copos);
  Repeat
    Rota(55,254);
    Nieve( copos);
  Until KeyPressed;
  Modo(3);
End.